



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BLEU (Bilingual Evaluation Understudy)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BLEU (Bilingual Evaluation Understudy)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 19:23:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<h2>什么是BLEU？</h2>
<blockquote><p>BLEU (Bilingual Evaluation Understudy) is an algorithm for evaluating the quality of text which has been <strong>machine-translated</strong> from one <strong>natural language</strong> to another. Quality is considered to be the correspondence between a machine's output and that of a human: "the closer a machine translation is to a professional human translation, the better it is" &ndash; this is the central idea behind BLEU. BLEU was one of the first metrics to achieve a high correlation with human judgements of quality, and remains one of the most popular automated and inexpensive metric. -- 维基百科</p></blockquote>
<p>解释一下，首先bleu是一种<strong>文本评估算法</strong>，它是用来评估<strong>机器翻译</strong>跟<strong>专业人工翻译</strong>之间的对应关系，核心思想就是<strong>机器翻译越接近专业人工翻译，质量就越好</strong>，经过bleu算法得出的分数可以作为机器翻译质量的其中一个指标。</p>
<h2>为什么要用BLEU？</h2>
<p>现实中很多时候我们需要用人工来评价翻译结果的，但这种方式非常慢，并且成本非常高，因为你需要请足够专业的翻译人员才能给出相对靠谱的翻译评估结果，一般这种人工评价都偏主观，并且非常依赖专业水平和经验。</p>
<p>为了解决这一问题，机器翻译领域的研究人员就发明了一些自动评价指标比如BLEU，METEOR和NIST等，在这些自动评价指标当中，<strong>BLEU是目前最接近人类评分</strong>的。</p>
<blockquote><p>METEOR和NIST评价指标，笔者还未做深入研究，有机会会针对这几个指标做个对比。</p></blockquote>
<h2>BLEU的原理是什么？</h2>
<p>为什么BLEU能作为机器翻译的一个评估指标，还是得看看它的原理是什么。</p>
<p>接下来我们逐个这几个概念：</p>
<ul><li>N-gram</li>
<li>惩罚因子</li>
<li>Bleu算法</li></ul>
<p><strong>N-gram</strong></p>
<blockquote><p>N-gram是一种统计语言模型，该模型可以将一句话表示n个连续的单词序列，利用上下文中相邻词间的搭配信息，计算出句子的概率，从而判断一句话是否通顺。</p></blockquote>
<p>BLEU也是采用了N-gram的匹配规则，通过它能够算出比较译文和参考译文之间n组词的相似的一个占比。</p>
<p>例子：</p>
<blockquote><p>原文： 猫坐在垫子上<br />
机器翻译：The cat sat on the mat.<br />
人工翻译：The cat is on the mat.</p></blockquote>
<p>我们分别看下1-4 gram的匹配情况：</p>
<p><strong>1-gram</strong></p>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-594aba123f1c7e23?imageMogr2/auto-orient/strip%7CimageView2/2/w/808/format/webp" /></div>
</div>
<div>1-gram</div>
</div>
<p>可以看到机器翻译6个词，有5个词命中参考以为，那么它的匹配度为 5/6。</p>
<p><strong>2-gram</strong></p>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-81e46ed036c63c1b?imageMogr2/auto-orient/strip%7CimageView2/2/w/974/format/webp" /></div>
</div>
<div>2-gram</div>
</div>
<p>2元词组的匹配度则是 3/5。</p>
<p><strong>3-gram</strong></p>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-6da346615eeef815?imageMogr2/auto-orient/strip%7CimageView2/2/w/934/format/webp" /></div>
</div>
<div>3-gram</div>
</div>
<p>3元词组的匹配度是1/4。</p>
<p><strong>4-gram</strong></p>
<p>4元词组的匹配情况就没有了。</p>
<p>经过上面的举例你应该很清楚n-gram是怎么计算了吧。一般情况1-gram可以代表原文有多少词被单独翻译出来，可以反映译文的<strong>充分性</strong>，2-gram以上可以反映译文的<strong>流畅性</strong>，它的值越高说明可读性越好。这两个指标是能够跟人工评价对标的。</p>
<p>但是它存在一些特殊情况，通过n-gram是没办法反映译文的正确性的，例如：</p>
<blockquote><p>原文：猫坐在垫子上<br />
机器译文： the the the the the the the.<br />
参考译文：The cat is on the mat.</p></blockquote>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-0f0faca9343d060e?imageMogr2/auto-orient/strip%7CimageView2/2/w/848/format/webp" /></div>
</div>
<div>1-gram错误情况</div>
</div>
<p>如果计算1-gram的话，你会发现所有the都匹配上了，匹配度是<code>7/7</code>，这个肯定不能反映充分性的，怎么办？</p>
<p>BLEU修正了这个算法，提出取机器翻译译文N-gram的出现次数和参考译文中N-gram最大出现次数中的最小值的算法，具体如下：</p>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-164989210dba0e4a?imageMogr2/auto-orient/strip%7CimageView2/2/w/345/format/webp" /></div>
</div>
<div>这里写图片描述</div>
</div>
<p>所以上面修正后的结果应该是count = 7，Max_ref_Count = 2，取它们之间的最小值为2，那么修正后的1-gram的匹配度应该为<code>2/7</code>。</p>
<p>是时候拿出论文中的计算各阶N-gram的精度计算公式：</p>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-07e81873d3416c17?imageMogr2/auto-orient/strip%7CimageView2/2/w/980/format/webp" /></div>
</div>
<div>Pn</div>
</div>
<p>一眼看过去是不是觉得很高大上，看不懂了有木有，解释一下吧：</p>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-0099c5cfaf0d1fe7?imageMogr2/auto-orient/strip%7CimageView2/2/w/830/format/webp" /></div>
</div>
<div>这里写图片描述</div>
</div>
<blockquote><p>表示取n-gram在翻译译文和参考译文中出现的最小次数，比如上面的1-gram出现的最小次数是2.</p></blockquote>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-cd1dfb0dffb21d9c?imageMogr2/auto-orient/strip%7CimageView2/2/w/794/format/webp" /></div>
</div>
<div>这里写图片描述</div>
</div>
<blockquote><p>表示取n-gram在翻译译文中出现次数，比如上面的1-gram出现的次数是7.</p></blockquote>
<p>ok，到这里你基本清楚bleu中n-gram精度到底是怎么计算的了。</p>
<p>上面的计算已经足够好了吗？ No，还得继续改进，举个例子：</p>
<blockquote><p>机器译文：The cat<br />
参考译文：The cat is on the mat.</p></blockquote>
<p>如果出现这种短句子，你会发现计算n-gram的精度会得很高分，很显然这次的得分为1，但实际上它的得分应该是比较低的。针对翻译译文长度比参考译文要短的情况，就需要一个惩罚的机制去控制。</p>
<p><strong>惩罚因子</strong></p>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-3cc9251a43d1da1a?imageMogr2/auto-orient/strip%7CimageView2/2/w/648/format/webp" /></div>
</div>
<div>BP</div>
</div>
<p>这里的c是机器译文的词数，r是参考译文的词数，</p>
<p>这样的话我们重新算精度就应该是：</p>
<p>BP = e^(1- 6 / 2) = 7.38905609893065</p>
<blockquote><p>e是一个常无理数,是一个无限不循环小数,所以用e来表示2.718281828</p></blockquote>
<p><strong>Bleu算法</strong></p>
<p>经过上面的各种改进，BLEU最终的计算公式如下：</p>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-88dd0bb4e6df070e?imageMogr2/auto-orient/strip%7CimageView2/2/w/726/format/webp" /></div>
</div>
<div>BLEU</div>
</div>
<p>BP我们已经知道了，那么</p>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-c7efeba373ee4899?imageMogr2/auto-orient/strip%7CimageView2/2/w/442/format/webp" /></div>
</div>
<div>这里写图片描述</div>
</div>
<p>又是什么鬼？先不用想这么多，其实就是一些数学运算，它的作用就是让各阶n-gram取<strong>权重服从均匀分布</strong>，就是说不管是1-gram、2-gram、3-gram还是4-gram它们的作用都是同等重要的。由于随着n-gram的增大，总体的精度得分是呈指数下降的，所以一般<strong>N-gram最多取到4-gram</strong>。</p>
<h2>怎么使用BLEU？</h2>
<p>说实话，数学用人话来解释是非常困难的，我们还是来通过例子来学习，还是之前的：</p>
<blockquote><p>机器翻译：The cat sat on the mat.<br />
人工翻译：The cat is on the mat.</p></blockquote>
<p><strong>第一步：计算各阶n-gram的精度</strong></p>
<p>P1 = 5 / 6 = 0.833333333333333<br />
P2 = 3 / 5 = 0.6<br />
P3 = 1 / 4 = 0.25<br />
P4 = 0 / 3 = 0</p>
<p><strong>第二步：加权求和</strong></p>
<p>取权重：Wn = 1 / 4 = 0.25</p>
<p>加权求和：</p>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-383a77a90efa9d04.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1000/format/webp" /></div>
</div>
<div>加权求和</div>
</div>
<p><strong>第三步：求BP</strong></p>
<p>机器翻译长度 = 参考译文长度，所以：</p>
<p><code>BP = 1</code></p>
<p><strong>最后求BLEU</strong></p>
<div>
<div>
<div>&nbsp;</div>
<div><img referrerpolicy="no-referrer"src="//upload-images.jianshu.io/upload_images/224008-f4a325f9586a95ee.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1000/format/webp" /></div>
</div>
<div>BLEU计算</div>
</div>
<p>写程序的时候，不用费那么大的劲去实现上面的算法，现成的工具就可以用:</p>
<pre class="prettyprint linenums"><code>from nltk.translate.bleu_score import sentence_bleu<br />
reference = [['The', 'cat', 'is', 'on', 'the', 'mat']]<br />
candidate = ['The', 'cat', 'sat', 'on', 'the', 'mat']<br />
score = sentence_bleu(reference, candidate)<br />
print(score)<br />
# 输出结果：0.5946035575013605<br />
</code></pre>
<h2>BLEU的优缺点？</h2>
<p><strong>优点</strong>：方便、快速，结果比较接近人类评分。</p>
<p><strong>缺点</strong>：</p>
<ol><li>不考虑语言表达（语法）上的准确性；</li>
<li>测评精度会受常用词的干扰；</li>
<li>短译句的测评精度有时会较高；</li>
<li>没有考虑同义词或相似表达的情况，可能会导致合理翻译被否定；</li></ol>
<p>BLEU本身就不追求百分之百的准确性，也不可能做到百分之百，它的目标只是给出一个快且不差的自动评估解决方案。</p>
<h2>最后</h2>
<p>BLEU原理其实并不是很复杂，更多是基于n-gram基础上的优化，写这篇文章的目的也是想梳理清楚BLEU能够解决的问题，还有不能解决的问题，这对自己后续思考如何通过其他手段去更好地提高翻译评估的能力有一定的启发作用。翻译质量评估本身就是MT领域的热门课题，如果我们能够找到一个比BLEU更好的，这将会产生很大的价值。</p>
<p>最后，文中很多内容从其他参考文章都可以找到，参考文章对BLEU如何计算，原理也有很不错的讲解，大家也可以参考学习下。</p>
<h2>参考文章</h2>
<ul><li><a href="https://link.jianshu.com?t=http%3A%2F%2Fwww.cnblogs.com%2Fby-dream%2Fp%2F7679284.html" rel="external nofollow noreferrer">机器翻译评测&mdash;&mdash;BLEU算法详解</a></li>
<li><a href="https://link.jianshu.com?t=https%3A%2F%2Fblog.csdn.net%2Fguolindonggld%2Farticle%2Fdetails%2F56966200" rel="external nofollow noreferrer">机器翻译评价指标之BLEU详细计算过程</a></li>
<li><a href="https://link.jianshu.com?t=https%3A%2F%2Fblog.csdn.net%2Fqq_31584157%2Farticle%2Fdetails%2F77709454" rel="external nofollow noreferrer">机器翻译自动评估-BLEU算法详解</a></li>
<li><a href="https://link.jianshu.com?t=https%3A%2F%2Fcloud.tencent.com%2Fdeveloper%2Farticle%2F1042161" rel="external nofollow noreferrer">浅谈用Python计算文本BLEU分数</a></li></ul>
</div>
<p>作者：IT_xiao小巫<br />链接：https://www.jianshu.com/p/15c22fadcba5<br />来源：简书<br />简书著作权归作者所有，任何形式的转载都请联系作者获得授权并注明出处。</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8o01me8.html">Spirng中Mongodb中write-concern的解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jwpxw8.html">Asp&period;net通过Jquery操作WebService进行Ajax读写</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2r6zw9.html">typedef和&num;define</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmj22e9.html">Android高效加载大图，多图解决方案，有效避免程序OOM异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1jpl69.html">JaxWsDynamicClientFactory弃用了，改成org&period;codehaus&period;xfire&period;client&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd4oyk8.html">Django处理文件上传File Uploads</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z6yl59.html">JavaScript 操作 DOM 常用 API 总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd7wl38.html">java&mdash;&mdash;数据库&mdash;&mdash;commons-DbUtils</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1prom9.html">python 推导式和迭代器、生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w7n7xq.html">maven项目启动</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp5lr7q.html">php事件驱动</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2x7voq.html">table表格&lpar;笔记&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2ze10q.html">学习CSS布局 - max-width</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w0ypwq.html">课程一&lpar;Neural Networks and Deep Learning&rpar;，第四周（Deep Neural Networks）&mdash;&mdash; 1&period;Practice Questions&colon; Key concepts on Deep Neural Networks</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vk6vzq.html">Android -- Drag&amp;amp&semi;&amp;amp&semi;Drop</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj25yp8.html">案例：用Redis来存储关注关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvee6lx9.html">js中如何以最简单的方式将数组元素添加到对象中</a>
		</li>
						<li><a href="https://www.batexi.com/a/qverj1x9.html">python之model模块和包的介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpxdne9.html">SSH项目整合</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44j5jnq.html">autocomplete 属性 清除input框输入存留历史值&comma;防止下拉历史值显示</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j1p32g9.html">centos中less翻页查询的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2p1n2q.html">Python学习（六） &mdash;&mdash; 函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv03ly8.html">使用ycsb对hbase1&period;4&period;9 benchmark</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o15mg1q.html">python对象、引用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyj00x9.html">BZOJ2821 作诗&lpar;Poetize&rpar; 主席树 bitset</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2065z9.html">AtCoder Regular Contest 100 &lpar;ARC100&rpar; E - Or Plus Max 其他</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj5y0r9.html">Codeforces Round &num;487 &lpar;Div&period; 2&rpar; 跌分有感</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7on43x8.html">java生成Excel文件，下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy5wz2q.html">Linux命令集</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy41ox9.html">002&period;Oracle安装部署-ASM</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
